﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Sockets;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Toolkit.Log4;
using Toolkit.Tcp;
using TouchSocket.Core;
using TouchSocket.Sockets;

namespace Toolkit.Core
{
    public class Management
    {


        public Management() { }

        public string MsgSplit(string str)
        {

            StringBuilder sb = new StringBuilder();
            try
            {

                str = str.Trim();
                string[] strs = str.Split(';');

                MesMsg msg = new MesMsg();

                Type personType = msg.GetType();

                PropertyInfo[] properties = msg.GetType().GetProperties();

                for ( int i = 0; i < strs.Length; i++ )
                {
                    for ( int j = 0; j < properties.Length; j++ )
                    {
                        string temp=strs[ i ].Split(':')[ 0 ].ToString();
                        if ( temp.Trim() == properties[ j ].Name )
                        {
                            string []splits=strs[ i ].Split(':');
                            string splitst="";
                            //if ( splits.Length > 2 )
                            //{
                            //    string[] newArray = new string[splits.Length - 1];
                            //    Array.Copy(splits, 1, newArray, 0, newArray.Length);
                            //    splits[ 0 ] = "";
                            //    splitst = string.Join(":", newArray);

                            //}
                            //else 
                            //{
                            splitst = strs[ i ].Split(':')[ 1 ];
                            // }
                            properties[ j ].SetValue(msg, splitst);
                            break;
                        }
                    }
                }


                sb.Append(msg.tasknum + ":|:");
                sb.Append(msg.client_name + ":|:");
                sb.Append(msg.datetime + ":|:");
                sb.Append(msg.phone + ":|:");
                string[] items = msg.items.Trim().Split(']');
                string amount = "";
                //string amountT="0";
                for ( int i = 0; i < 9; i++ )
                {
                    if ( items.Length > i )
                    {
                        if ( items[ i ].Length == 0 )
                        {
                            sb.Append(" " + ":|:");
                            sb.Append(" " + ":|:");
                            sb.Append(" " + ":|:");
                            sb.Append(" " + ":|:");
                            continue;
                        }
                        int startindex = items[i].IndexOf("<") + 1;
                        int stopindex = items[i].IndexOf(">") - startindex;
                        amount = items[ i ].Substring(startindex, stopindex);
                        items[ i ] = items[ i ].Substring(items[ i ].IndexOf(">") + 1);
                        startindex = items[ i ].IndexOf("<") + 1;
                        stopindex = items[ i ].IndexOf(">") - startindex;
                        string currcycode = items[i].Substring(startindex, stopindex);
                        //items:[amount<300>currcycode<USD>itdetail<100 | 1,50 | 4 >][...];
                        items[ i ] = items[ i ].Substring(items[ i ].IndexOf(">") + 1);
                        string[] itdetail = items[i].Split(',');
                        for ( int j = 0; j < itdetail.Length; j++ )
                        {
                            if ( j != 0 )
                                i++;
                            sb.Append(currcycode + ":|:");
                            startindex = itdetail[ j ].IndexOf("<") + 1;
                            stopindex = itdetail[ j ].IndexOf("|") - startindex;
                            sb.Append(( itdetail[ j ].Substring(startindex, stopindex) ) + ":|:");
                            string numStr=itdetail[ j ].Substring(startindex, stopindex);
                            int num=0;
                            if ( numStr != "?" )
                                num = Convert.ToInt32(numStr);
                            startindex = itdetail[ j ].IndexOf("|") + 1;
                            stopindex = itdetail[ j ].IndexOf(">");
                            if ( stopindex == -1 )
                            {

                                if ( itdetail[ j ].Substring(startindex) == "?" )
                                {
                                    sb.Append("?:|:");
                                    sb.Append("?:|:");
                                }
                                else
                                {
                                    int count = Convert.ToInt32(itdetail[ j ].Substring(startindex));
                                    sb.Append(count + ":|:");
                                    sb.Append(num * count + ":|:");
                                }
                            }
                            else
                            {

                                if ( itdetail[ j ].Substring(startindex, stopindex - startindex) == "?" )
                                {
                                    sb.Append("?:|:");
                                    sb.Append("?:|:");

                                }
                                else
                                {
                                    int count = Convert.ToInt32(itdetail[ j ].Substring(startindex, stopindex - startindex));
                                    sb.Append(count + ":|:");
                                    sb.Append(num * count + ":|:");
                                }





                            }
                        }
                        //if ( amount == "?" )
                        //{
                        //    amountT ="?";
                        //}
                        //else 
                        //{
                        //    amountT = (Convert.ToDouble(amount)+ Convert.ToDouble(amountT)).ToString();
                        //}

                    }
                    else
                    {
                        sb.Append(" " + ":|:");
                        sb.Append(" " + ":|:");
                        sb.Append(" " + ":|:");
                        sb.Append(" " + ":|:");
                    }
                }
                //[amount<500>currcycode<CNY>]
                string []currcycodes=msg.suminfo.Split("currcycode");
                string []amounts=msg.suminfo.Split("amount");
                for ( int i = 0; i < currcycodes.Length; i++ )
                {

                }
               
                sb.Append(msg.suminfo + ":|:");
                sb.Append(msg.recv_date + ":|:");
                sb.Append(msg.deal_name + ":|:");
                sb.Append(msg.tasknum + ":|:");
                sb.Append(msg.dep_name + ":|:");
                sb.Append(msg.packinfo + ":|:");
                //sb.Append(msg.packno + ":|:");
                //sb.Append(msg.totalpack + ":|:");
                if ( msg.taskstatus == "0" )
                {
                    sb.Append("正常");
                }
                else
                {
                    sb.Append("异常");
                }
                string oldstr=sb.ToString();
                string newstr=oldstr.Replace(":|:",",");
                string []sbs=newstr.Split(",");
                string logprint="";
                for ( int i = 0; i < sbs.Length; i++ )
                {
                    logprint += "    " + ( i + 1 ) + ":" + sbs[ i ];
                }
                LogHelper.Info(logprint);

            }
            catch ( Exception ex )
            {
                LogHelper.error.Error("解析异常", ex);
                return "Err";
            }


            return sb.ToString();
        }


        public byte[] GetData(string NowSendData, int printcount = 1, int autostop = 0, int encode = 1)
        {
            string sends = "";
            byte[] endbyte = new byte[] { 00, 00, 03, 04 };


            byte[] VerBin = new byte[10000];
            //计算校验字节。
            byte VerByte = 0;
            List<byte> CRCBuffer = new List<byte>();
            CRCBuffer.Add(0x1D);                                      //起始
            CRCBuffer.Add(( byte ) ( printcount & 0xff ));
            CRCBuffer.Add(( byte ) ( ( printcount & 0xff00 ) >> 8 ));
            CRCBuffer.Add(( byte ) ( ( printcount & 0xff0000 ) >> 16 ));
            CRCBuffer.Add(( byte ) ( ( printcount & 0xff000000 ) >> 24 ));

            if ( autostop == 0 )
                CRCBuffer.Add(0x0A);
            else
                CRCBuffer.Add(0x0B);
            encode = 1;     //220904统一采用utf8格式发送，解决部分gb2312乱码（二维码中）
            switch ( encode )
            {
                case 0:
                    VerBin = System.Text.Encoding.GetEncoding("gb2312").GetBytes(NowSendData);
                    CRCBuffer.Add(0xC1);
                    break;
                case 1:
                    VerBin = System.Text.Encoding.UTF8.GetBytes(NowSendData);
                    CRCBuffer.Add(0xC2);
                    break;
                case 2:
                    VerBin = System.Text.Encoding.Unicode.GetBytes(NowSendData);
                    CRCBuffer.Add(0xC3);
                    break;
            }

            CRCBuffer.AddRange(VerBin);                               //数据
            VerByte = CRC8(CRCBuffer.ToArray());
            CRCBuffer.Add(VerByte);
            CRCBuffer.AddRange(endbyte);
            byte[] sendbuff = CRCBuffer.ToArray();



            return sendbuff;

        }




        public static byte CRC8(byte[] buffer)
        {
            byte crc = 0;
            for ( int j = 0; j < buffer.Length; j++ )
            {
                crc ^= buffer[ j ];
                for ( int i = 0; i < 8; i++ )
                {
                    if ( ( crc & 0x01 ) != 0 )
                    {
                        crc >>= 1;
                        crc ^= 0x8c;
                    }
                    else
                    {
                        crc >>= 1;
                    }
                }
            }
            return crc;
        }
    }
}
